﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BuilderPattern
{
    //建造者 定义建造产品的抽象方法和产品的引用
    abstract class ComputerBuilder
    {
        private Computer computerInstance;

        /// <summary>
        /// 返回建立的电脑产品实例
        /// </summary>
        public Computer ComputerInstance
        {
            get { return computerInstance; }
            set {  computerInstance=value; }
        }

        /// <summary>
        /// 创建电脑名称
        /// </summary>
        abstract public void CreateCompName();

        /// <summary>
        /// 创建电脑内存
        /// </summary>
        abstract public void CreateCompMemory();

        /// <summary>
        /// 创建电脑硬盘
        /// </summary>
        abstract public void CreateCompDisk();

    }
}
