﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BuilderPattern
{
    class Program
    {
        static void Main(string[] args)
        {
            //创建指挥者
            CreateDirector compDirector = new CreateDirector();
            //创建具体建造者
            ComputerBuilder hpComputer = new HpConcreteBuilder();
            ComputerBuilder ibmComputer = new IBMConcreteBuilder();
            ComputerBuilder dellComputer = new DellConcreteBuilder();
            ComputerBuilder appleComputer = new AppleConcreteBuilder();

            //指挥者调用具体建造者以创建产品
            compDirector.CreateComputer(hpComputer);
            //调用产品内部函数显示产品信息
            hpComputer.ComputerInstance.ShowComputerInfo();


            compDirector.CreateComputer(ibmComputer);
            ibmComputer.ComputerInstance.ShowComputerInfo();

            compDirector.CreateComputer(dellComputer);
            dellComputer.ComputerInstance.ShowComputerInfo();

            compDirector.CreateComputer(appleComputer);
            appleComputer.ComputerInstance.ShowComputerInfo();

            Console.ReadLine();
        }
    }
}
